# Tcl based calculation using an index accessor
# This is not possible because it tries to yield from inside the C stack:

proc get_from_record { the_record } {
    yield
    foreach_instance {
	# Can't yield here because foreach_instance (above) is a C command
        yield [ $the_record value ]
    }
    return -code break;
}


proc do_calculation { record } {

  coroutine data_fetcher get_from_record $record

  set wval 0.0
  set old_val 0.0
  set vlen 0
  while 1 {
    set value [ data_fetcher ]
    set wval [ expr { pow(1.009 + sqrt($old_val)*(1/(abs($wval)+0.001) + $value ), 1.0002) } ]
    set old_val [ expr { $wval/2.355832 } ]
    incr vlen
  }
  return [ expr { $wval/$vlen } ]
};

